//////////////////////////////////////////////////////////////////////
//
//  DBESYS.PRG
//
//  Copyright:
//      Alaska Software, (c) 1998-2001. All rights reserved.
//
//  Contents:
//      Xbase++ DatabaseEngine startup/preloader
//
//  Syntax:
//      DbeSys() is called automatically at program start before the
//      function MAIN.
//
//////////////////////////////////////////////////////////////////////

// PC CAW 03-05-05 Turn off optimize/rushmore/smartfilter

#define MSG_DBE_NOT_LOADED   " database engine not loaded"
#define MSG_DBE_NOT_CREATED  " database engine could not be created"

STATIC oDACSession

*******************************************************************************
* DbeSys() is always executed at program startup
*******************************************************************************

PROCEDURE dbeSys()
//
//   The lHidden parameter is set to .T. for all database engines
//   which will be combined to a new abstract database engine.
// 
  LOCAL aDbes := { { "DBFDBE", .T.},;
                   { "NTXDBE", .T.},;
                   { "CDXDBE", .T.},;
                   { "FOXDBE", .T.},;
                   { "DELDBE", .F.},;
                   { "SDFDBE", .F.}}
  LOCAL aBuild :={ { "DBFNTX", 1, 2 },;
                   { "DBFCDX", 1, 3 },;
                   { "FOXCDX", 4, 3} }
  LOCAL i
  LOCAL cSession
  LOCAL oThread

  SetAppWindow():hide()


  //
  //   Set the sorting order and the date format
  // 
  SET COLLATION TO AMERICAN                                             // changed for ADS
  SET DATE TO AMERICAN

  SET OPTIMIZE OFF
  SET RUSHMORE OFF
  SET SMARTFILTER OFF                                                   // PC CAW 03-05-05 Turn off optimize/rushmore/smartfilter

  //
  //   load all database engines
  // 
  FOR i:= 1 TO len(aDbes)
      IF ! DbeLoad( aDbes[i][1], aDbes[i][2])
         Alert( aDbes[i][1] + MSG_DBE_NOT_LOADED , {"OK"} )
      ENDIF
  NEXT i

  //
  //   create database engines
  // 
  FOR i:= 1 TO len(aBuild)
      IF ! DbeBuild( aBuild[i][1], aDbes[aBuild[i][2]][1], aDbes[aBuild[i][3]][1])
         Alert( aBuild[i][1] + MSG_DBE_NOT_CREATED , {"OK"} )
      ENDIF
  NEXT i
RETURN

FUNCTION oDACSession
  RETURN oDACSession

//
// EOF
