#INCLUDE "dcdialog.ch"
#include "dcbitmap.ch"
#INCLUDE "appevent.CH"
#include "dll.ch"
#include "common.ch"
#include "dcprint.ch"
#include "inkey.ch"

#define KEYEVENTF_KEYUP     0x02
#define VK_MENU             0x12
#define VK_SNAPSHOT         0x2C

FUNCTION Main()

  LOCAL GetList[0], GetOptions, oMenuBar, oSubMenu, oDlg 
  LOCAL ostatic, aSort[7], aSort2[8]
  LOCAL aWorkArea, aBrowPres
  LOCAL nFrameState, nWidth, nHeight, nWindowWidth, nWindowHeight, nWindowRow, nWindowCol
  LOCAL cSayFont, cGetFont, oPrntScrn, ODialer

  PUBLIC G_l1024

  DC_bitmaptransparentcolor({192,192,192})                                      // set transparent color for pushbuttons


  SETKEY(K_F12 ,     {|| LB_PrintScreen() } )
  m->G_l1024 := .T.

  DCMENUBAR oMenuBar
    DCSUBMENU oSubMenu PROMPT 'Test' PARENT oMenuBar
      DCMENUITEM CAPTION 'Test Window (Modal)' PARENT oSubMenu ;
        ACTION {|o|o:=Thread():new(),Sleep(10),o:start({||TestWindow(oDlg,1)})}
      DCMENUITEM CAPTION 'Test Window (Child)' PARENT oSubMenu ;
        ACTION {|o|o:=Thread():new(),Sleep(10),o:start({||TestWindow(oDlg,2)})}

//  DC_ReadGuiDebug(2)
  
  nFrameState   := XBPDLG_FRAMESTAT_NORMALIZED                          // default frame state is normalized
  aWorkArea     := DC_GetWorkArea()                                     // get current workarea size

  aSort[1] := GRA_CLR_WHITE             // Sort Selected Color (Foreground)
  aSort[2] := GRA_CLR_RED               // Sort Selected Color (Background)
  aSort[3] := GRA_CLR_BLACK             // Sort Unselected Color (Foreground)   //WHITE
  aSort[4] := GRA_CLR_PALEGRAY          // Sort Unselected Color (Background)
  aSort[5] := BITMAP_RD_UP_RED          // Sort UP Bitmap
  aSort[6] := BITMAP_RD_DOWN_RED        // Sort DOWN Bitmap
  aSort[7] := GRA_CLR_BLUE              // Sort Hilite box color

  aSort2[1] := GRA_CLR_WHITE            // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_RED              // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground)   //WHITE
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background)
  aSort2[5] := BITMAP_RD_UP_RED         // Sort UP Bitmap
  aSort2[6] := BITMAP_RD_DOWN_RED       // Sort DOWN Bitmap
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select
  

  nWindowWidth := 1250
  nWindowHeight := 912 //1000
  m->G_cGCaptionFont := '8.Tahoma'
  cSayFont := '10.Arial'
  cGetFont := '12.Lucida Console Bold'
  m->G_cGetFont := '12.Lucida Console Bold'
  m->G_nColPixels := 11.9
  m->G_nRowPixels := 26.25                            
  m->G_nBrowColPixels := 11.75                        
  m->G_cSortHeadFont := '11.Helv Bold'

  aBrowPres := ;
     {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
      { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
      { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
      { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
      { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
      { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
      { XBP_PP_COL_DA_ROWHEIGHT, 13.75 },                 /* Row Height       */  ;             // 13
      { XBP_PP_COL_DA_CELLHEIGHT, 13.75 },                /* Cell Height      */  ;             // 13
      { XBP_PP_COL_HA_HEIGHT, 13.75 },                    /* Header Height    */  ;             // 15
      { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
      { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
      { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
      { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
      { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
      { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
      { XBP_PP_COL_DA_COMPOUNDNAME,'11.Arial'},           /* Font             */  ;             // 11.Arial
      { XBP_PP_COL_HA_COMPOUNDNAME,'11.Helv'},            /* Font             */  ;
      { XBP_PP_COL_FA_HEIGHT, 15 },                       /* Footer Height    */  ;
      { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
     }


  DC_BrowPres(aBrowPres)                        // save browse presentation factors
  DC_BrowseSort(aSort2)                         // save browse sort factors             // PC CAW 01-13-05 changed from aSort to aSort2
  DC_FindBrowseSort(aSort)                      // save find browse sort factors

  nWindowCol := (aWorkArea[3]-nWindowWidth)/2 
  nWindowRow := ((AppDeskTop():currentsize()[2] - nWindowHeight + 28)/2)

  DCGETOPTIONS ;
    ICON DC_IconDefault() ;
    WINDOWHEIGHT nWindowHeight ;
    WINDOWWIDTH  nWindowWidth ;
    WINDOWCOL    nWindowCol ;                      //     (aWorkArea[3]-nWindowWidth)/2 ;                   // CHG
    WINDOWROW    nWindowRow ;                      //     (AppDeskTop():currentsize()[2] - nWindowHeight)/2 ;
    SAYFONT cSayFont ;
    GETFONT cGetFont ;
    FONT cSayFont ;
    COLPIXELS m->G_nColPixels ;
    ROWPIXELS m->G_nRowPixels ;
    ROWSPACE  m->G_nRowPixels ;
    GETHEIGHT m->G_nRowPixels-4 ;
    SAYHEIGHT m->G_nRowPixels-4 ;
    FITPAD 5 ;                                                  // changed from default of 10
    AUTOWINMENU ;    
    TOOLTIPCOLOR GRA_CLR_BLACK, GRA_CLR_WHITE ;
    NOESCAPEKEY ;
    HILITEGETS GRA_CLR_BLUE ;
            
    DC_GetOptDefault(GetOptions)            
    
    DCADDGETOPTION BITMAP 'FEATHERTEXTURE.BMP' HIDE

    IF version(3)>'336'
//      DCADDGETOPTION COLOR XBPSYSCLR_DIALOGBACKGROUND //XPPSYSCLR_WINDOW
    ENDIF

  DCREAD GUI TITLE 'Static/Tabpage Test' PARENT @oDlg OPTIONS GetOptions ;
    EVAL {|o| m->G_MainWindow := o,                               ;
              o:setFrameState(nFrameState),                       ;                                     // PC CAW 04-15-05 235testbuild change from above
              DC_StatusBarRepaint(o),o:show() }                   ;
   SETAPPWINDOW                                                   ;
   NODESTROY 

RETURN nil

* ------------

PROC appsys
RETURN

* ------------

STATIC FUNCTION TestWindow( oDlg, nMode )
//#include 'axcdxcmx.ch'

  LOCAL GetList[0], GetOptions, oParent, oToolBar, oAppWindow
  LOCAL dDate11, dDate21, oPagegroup1, oIdent1, oTabpage1, oTabstatic1,lCheck11 := .F.,lCheck21 := .F.
  LOCAL dDate12, dDate22, oPagegroup2, oIdent2, oTabpage2, oTabstatic2,lCheck12 := .F.,lCheck22 := .F.
  LOCAL dDate13, dDate23, oPagegroup3, oIdent3, oTabpage3, oTabstatic3,lCheck13 := .F.,lCheck23 := .F.
  LOCAL dDate14, dDate24, oPagegroup4, oIdent4, oTabpage4, oTabstatic4,lCheck14 := .F.,lCheck24 := .F.
  LOCAL dDate15, dDate25, oPagegroup5, oIdent5, oTabpage5, oTabstatic5,lCheck15 := .F.,lCheck25 := .F.
  LOCAL account := '500000001', date_enter := date()

  LOCAL nRow
  LOCAL aArray := {"line1","line2","line3","line4","line5","line6","line7","line8"}, oBrowse
  LOCAL IndexList1 :=  { "SIMPLE","SSN1","SSN2","HPHONE","CITY", ;
                         "ADDRESS","SNAME","COAPPNAME","EMPPHONE"}              // PC JAC 04-12-04           // defines sort tag orders
                         
  LOCAL IndexList2 :=  { "Account Number",                 ;                    // defines order description
                         "SSN #1",                         ;
                         "SSN #2",                         ;
                         "Home Telephone",                 ;
                         "City, State, Zip",               ;      
                         "Address",                        ;      
                         "Account Name",                   ;      
                         "Co-applicant Name",              ;    
                         "Employer Phone"   }                                   // PC JAC 04-12-04
                         
  LOCAL IndexList3 :=  { { "SIMPLE",    1 },  ;                                 // defines orders and whether browse columns can select
                         { "SSN1",      7 },  ;                                 // 1 - order; 2-can select in browse; 3-which column selects (0=none)
                         { "SSN2",     11 },  ;
                         { "HPHONE",    8 },  ;
                         { "CITY",     13 },  ;
                         { "ADDRESS",  12 },  ;
                         { "SNAME",     2 },  ;
                         { "COAPPNAME", 9 },  ;
                         { "EMPPHONE", 14 } }                                   // PC JAC 04-12-04    

  LOCAL bReorder                        //   action when order button pressed
                         
  LOCAL nTPWidth := 70, nTPHeight := 15, bBlock
  
  LOCAL fname := 'JOHN                      '
  LOCAL lname := 'DOE                       '
  LOCAL add_1 := '123 MY STREET             '
  LOCAL add_2 := 'APP #103                  '
  LOCAL city  := 'ANY CITY                  '
  LOCAL oDialog
  
  DCHOTKEY {xbeK_F12} ACTION {|| LB_PrintScreen( .F., .F., oDialog ) } 


  IF nMode = 1
    oAppwindow := nil
  ELSE
    oAppWindow := oDlg:drawingArea
  ENDIF

  dbeSetDefault('DBFCDX')

  SELECT 0
  USE SIMPLE SHARED VIA 'DBFCDX' ALIAS SIMPLE
  SET INDEX TO 'SIMPLE.CDX'
  SET ORDER TO 1

  bReOrder := {|| S_ReOrder(IndexList1,IndexList2,IndexList3, GetList)}         // Reorder key     

  dDate11 := Ctod('')
  dDate21 := Ctod('')
  dDate12 := Ctod('')
  dDate22 := Ctod('')
  dDate13 := Ctod('')
  dDate23 := Ctod('')
  dDate14 := Ctod('')
  dDate24 := Ctod('')
  dDate15 := Ctod('')
  dDate25 := Ctod('')

  @ 0,0 DCTABPAGE oTabpage1 ;                                                 // Tab Page 1 - Browse Screen
          ACCELKEY {xbeK_F2}     ;     
          TABWIDTH 13 ;
;//          EVAL {|o| LB_VisualStyle(o) }    ;
          EVAL {|o| o:UseVisualStyle := .F.} ;
          STATICAREA oTabstatic1 ;
          CAPTION 'F2. test11' ;
          SIZE nTPWidth,nTPHeight 

  @ 0,0 DCTABPAGE oTabpage2 ;
          ACCELKEY {xbeK_F3}     ;     
          RELATIVE oTabpage1 ;
;//          STATICAREA oTabstatic2 ;
          EVAL {|o| o:UseVisualStyle := .F.} ;
;//          EVAL {|o| LB_VisualStyle(o) }    ;
          CAPTION 'F3. test12' 
          
  @ 0,0 DCTABPAGE oTabpage3 ;
          ACCELKEY {xbeK_F4}     ;     
          RELATIVE oTabpage2 ;
          STATICAREA oTabstatic3 ;
          EVAL {|o| LB_VisualStyle(o) }    ;
          CAPTION 'F4. test21' 

  @ 0,0 DCTABPAGE oTabpage4 ;
          ACCELKEY {xbeK_F5}     ;     
          RELATIVE oTabpage3 ;
;//          STATICAREA oTabstatic4 ;
          EVAL {|o| LB_VisualStyle(o) }    ;
          CAPTION 'F5. test22' 

  @ 0,0 DCTABPAGE oTabpage5 ;
          ACCELKEY {xbeK_F6}     ;     
          RELATIVE oTabpage4 ;
;//          STATICAREA oTabstatic5 ;
          EVAL {|o| LB_VisualStyle(o) }    ;
          CAPTION 'F6. test23' 

  // TabPage1

  DCSETPARENT TO oTabstatic1
  DCSETGROUP  TO 'TABSTATIC1'

  @ .2, 1.1 DCSAY 'Account #' GET account PICTURE '@K!'

  @ .2, DCGUI_COL+4 DCSAY 'Date Entered' GET date_enter PICTURE '@D' ;
            SAYSIZE 0 ;
            EDITPROTECT {|| .T.} ;
            GETCOLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND 

  bBlock := 'TestStatus'
  @ .2, DCGUI_COL+10 DCSAY bblock SAYHORIZCENTER SAYSIZE 13 

  @ .2, 52 DCSAY {|| 'Order:  ' + DC_PickCase( SIMPLE->(OrdSetFocus()),'==', ;
                                               IndexList1, IndexList2 ) } ;
           SAYSIZE 17 ;
           GROUP 'ORDNAME' 


  @ 1.3,.4 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup1 ;
;//             COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
;//             COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND ;
             SIZE nTPWidth-1.2,nTPHeight-2.9 PARENT oTabstatic1

  @ .1, .5  DCGROUP oIdent1 SIZE nTPWidth-2,11.7 ;
              PARENT oPagegroup1 ;
              CAPTION 'Identification' 

  DCSETPARENT TO oIdent1
  nRow := 1

  @ nRow++,3 DCGET dDate11

  @ nRow++,3 DCGET dDate21

  @ nRow,2 DCCHECKBOX lCheck11 PROMPT 'Checkbox' SIZE 10,1 ;
        COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow,20 DCCHECKBOX lCheck21 PROMPT '' SIZE 1.4,.65 WHEN {|| .F. };
       COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow++,30 DCCHECKBOX lCheck21 PROMPT '' SIZE 1.4,.65 WHEN {|| .T. };
        COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow++, .5 DCSAY 'Applicant' GET fname   ;
                  PICTURE '@K!'      
  @ nRow++, .5 DCSAY 'Applicant' GET lname   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_1   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_2   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET city    ;
                  PICTURE '@K!'                                                


  // TabPage2

  DCSETPARENT TO oTabpage2
  DCSETGROUP  TO 'TABSTATIC2'

  @ 1.2, 1.3 DCSAY 'Account #' GET account PICTURE '@K!'

  @ 1.2, DCGUI_COL+4 DCSAY 'Date Entered' GET date_enter PICTURE '@D' ;
            SAYSIZE 0 ;
            EDITPROTECT {|| .T.} ;
            GETCOLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND 

  bBlock := 'TestStatus'
  @ .2, DCGUI_COL+10 DCSAY bblock SAYHORIZCENTER SAYSIZE 13 

  @ 1.2, 52 DCSAY {|| 'Order:  ' + DC_PickCase( SIMPLE->(OrdSetFocus()),'==', ;
                                               IndexList1, IndexList2 ) } ;
           SAYSIZE 17 ;
           GROUP 'ORDNAME' 


  @ 2.3,.7 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup2 ;
;//             COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
;//             COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND ;
             SIZE nTPWidth-1.2,nTPHeight-2.9 PARENT oTabpage2

  @ .1, .6  DCGROUP oIdent2 SIZE nTPWidth-2,11.7 ;
              PARENT oPagegroup2 ;
              CAPTION 'Identification' 

  DCSETPARENT TO oIdent2
  nRow := 1

  @ nRow++,3 DCGET dDate12

  @ nRow++,3 DCGET dDate22

  @ nRow,2 DCCHECKBOX lCheck21 PROMPT 'Checkbox' SIZE 10,1 ;
        COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow,20 DCCHECKBOX lCheck22 PROMPT '' SIZE 1.4,.65 WHEN {|| .F. };
       COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow++,30 DCCHECKBOX lCheck22 PROMPT '' SIZE 1.4,.65 WHEN {|| .T. };
        COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND

  @ nRow++, .5 DCSAY 'Applicant' GET fname   ;
                  PICTURE '@K!'      
  @ nRow++, .5 DCSAY 'Applicant' GET lname   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_1   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_2   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET city    ;
                  PICTURE '@K!'                                                


  // TabPage3


  DCSETPARENT TO oTabstatic3
  DCSETGROUP  TO 'TABSTATIC3'

  @ 0.2, 1.1 DCSAY 'Account #' GET account PICTURE '@K!'

  @ 0.2, DCGUI_COL+4 DCSAY 'Date Entered' GET date_enter PICTURE '@D' ;
            SAYSIZE 0 ;
            EDITPROTECT {|| .T.} ;
            GETCOLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND 

  bBlock := 'TestStatus'
  @ 0.2, DCGUI_COL+10 DCSAY bblock SAYHORIZCENTER SAYSIZE 13 

  @ 0.2, 52 DCSAY {|| 'Order:  ' + DC_PickCase( SIMPLE->(OrdSetFocus()),'==', ;
                                               IndexList1, IndexList2 ) } ;
           SAYSIZE 17 ;
           GROUP 'ORDNAME' 


  @ 1.3,.4 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup3 ;
;//             COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
;//             COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND ;
             SIZE nTPWidth-1.2,nTPHeight-2.9 PARENT oTabstatic3

  @ .1, .5  DCGROUP oIdent3 SIZE nTPWidth-2,11.7 ;
              PARENT oPagegroup3 ;
              CAPTION 'Identification' 

  DCSETPARENT TO oIdent3
  nRow := 1

  @ nRow++,3 DCGET dDate13

  @ nRow++,3 DCGET dDate23

  @ nRow,2 DCCHECKBOX lCheck13 PROMPT 'Checkbox' SIZE 10,1 ;
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow,20 DCCHECKBOX lCheck23 PROMPT '' SIZE 1.4,.65 WHEN {|| .F. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++,30 DCCHECKBOX lCheck23 PROMPT '' SIZE 1.4,.65 WHEN {|| .T. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++, .5 DCSAY 'Applicant' GET fname   ;
                  PICTURE '@K!'      
  @ nRow++, .5 DCSAY 'Applicant' GET lname   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_1   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_2   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET city    ;
                  PICTURE '@K!'                                                

  // TabPage4


  DCSETPARENT TO oTabpage4
  DCSETGROUP  TO 'TABSTATIC4'

  @ 1.2, 1.3 DCSAY 'Account #' GET account PICTURE '@K!'

  @ 1.2, DCGUI_COL+4 DCSAY 'Date Entered' GET date_enter PICTURE '@D' ;
            SAYSIZE 0 ;
            EDITPROTECT {|| .T.} ;
            GETCOLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND 

  bBlock := 'TestStatus'
  @ 1.2, DCGUI_COL+10 DCSAY bblock SAYHORIZCENTER SAYSIZE 13 

  @ 1.2, 52 DCSAY {|| 'Order:  ' + DC_PickCase( SIMPLE->(OrdSetFocus()),'==', ;
                                               IndexList1, IndexList2 ) } ;
           SAYSIZE 17 ;
           GROUP 'ORDNAME' 


  @ 2.3,.7 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup4 ;
;//             COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
;//             COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND ;
             SIZE nTPWidth-1.2,nTPHeight-2.9 PARENT oTabpage4

  @ .1, .6  DCGROUP oIdent4 SIZE nTPWidth-2,11.7 ;
              PARENT oPagegroup4 ;
              CAPTION 'Identification' 

  DCSETPARENT TO oIdent4
  nRow := 1

  @ nRow++,3 DCGET dDate14

  @ nRow++,3 DCGET dDate24

  @ nRow,2 DCCHECKBOX lCheck14 PROMPT 'Checkbox' SIZE 10,1 ;
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow,20 DCCHECKBOX lCheck24 PROMPT '' SIZE 1.4,.65 WHEN {|| .F. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++,30 DCCHECKBOX lCheck24 PROMPT '' SIZE 1.4,.65 WHEN {|| .T. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++, .5 DCSAY 'Applicant' GET fname   ;
                  PICTURE '@K!'      
  @ nRow++, .5 DCSAY 'Applicant' GET lname   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_1   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_2   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET city    ;
                  PICTURE '@K!'                                                


  // TabPage5


  DCSETPARENT TO oTabpage5
  DCSETGROUP  TO 'TABSTATIC5'

  @ 1.2, 1.3 DCSAY 'Account #' GET account PICTURE '@K!'

  @ 1.2, DCGUI_COL+4 DCSAY 'Date Entered' GET date_enter PICTURE '@D' ;
            SAYSIZE 0 ;
            EDITPROTECT {|| .T.} ;
            GETCOLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND 

  bBlock := 'TestStatus'
  @ 1.2, DCGUI_COL+10 DCSAY bblock SAYHORIZCENTER SAYSIZE 13 

  @ 1.2, 52 DCSAY {|| 'Order:  ' + DC_PickCase( SIMPLE->(OrdSetFocus()),'==', ;
                                               IndexList1, IndexList2 ) } ;
           SAYSIZE 17 ;
           COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
           GROUP 'ORDNAME' 


  @ 2.3,.6 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup5 ;
             COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT ;
;//             COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND ;
             SIZE nTPWidth-1.2,nTPHeight-2.9 PARENT oTabpage5

  @ .1, .5  DCGROUP oIdent5 SIZE nTPWidth-2,11.7 ;
              PARENT oPagegroup5 ;
              CAPTION 'Identification' 

  DCSETPARENT TO oIdent5
  nRow := 1

  @ nRow++,3 DCGET dDate15

  @ nRow++,3 DCGET dDate25

  @ nRow,2 DCCHECKBOX lCheck15 PROMPT 'Checkbox' SIZE 10,1 ;
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow,20 DCCHECKBOX lCheck25 PROMPT '' SIZE 1.4,.65 WHEN {|| .F. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++,30 DCCHECKBOX lCheck25 PROMPT '' SIZE 1.4,.65 WHEN {|| .T. };
        COLOR GRA_CLR_BLACK, XBPSYSCLR_TRANSPARENT

  @ nRow++, .5 DCSAY 'Applicant' GET fname   ;
                  PICTURE '@K!'      
  @ nRow++, .5 DCSAY 'Applicant' GET lname   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_1   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET add_2   ;
                  PICTURE '@K!'                                                
  @ nRow++, .5 DCSAY 'Applicant' GET city    ;
                  PICTURE '@K!'                                                


DCSETPARENT TO 
nRow := nTPHeight+1.2

  @ nRow, 2 DCTOOLBAR oToolBar SIZE 60-1 BUTTONSIZE 7,1

  DCADDBUTTON PARENT oToolBar ;                                                 // Home key |<-
    SIZE 3,1 ;                                                                  //   defined when not in edit mode and not BOF
    CAPTION {BITMAP_TOP_S,BITMAP_TOP_DISABLED_S} ;                              //   defined only for the HOME key
    ACTION {|| dc_debugqout('top') } ;                                          //   defined for all tab pages           
    WHEN {|| .F.}
                                                                                
  DCADDBUTTON PARENT oToolBar ;                                                 // Previous key <-
    SIZE 3,1 ;                                                                  //   defined when not in edit mode and not BOF
    CAPTION {BITMAP_TOP_S,BITMAP_TOP_DISABLED_S} ;                              //   defined only for the HOME key
;// CAPTION "<" FONT "10.MS Sans Serif" ;
    ACTION {|| dc_debugqout('prev') }                                                                //   defined for all tab pages
   
  DCADDBUTTON PARENT oToolBar ;                                                 // Next key ->
    SIZE 3,1 ;                                                                  //   defined when not in edit mode and not EOF
    CAPTION ">" FONT "10.MS Sans Serif" ;
    ACTION {|| dc_debugqout('prev') }

  DCADDBUTTON PARENT oToolBar CAPTION '~Order' ;                              // Index Order Key
    SIZE 5,1 ;                                                                //   defined for edit mode
    ACTION  bReorder ;    
    ACCELKEY {xbeK_ALT_O}


/*
@ 4,0 DCBROWSE oBrowse DATA aArray SIZE 15,6 

DCBROWSECOL ELEMENT 1 PARENT oBrowse WIDTH 13
*/


DCGETOPTIONS                    ;
  HILITEGETS GRA_CLR_BLUE       ;
  COLORGETS { {GRA_CLR_BLACK, GRA_CLR_YELLOW},{GRA_CLR_BLACK,GRA_CLR_WHITE} } ;

  

DCREAD GUI FIT TITLE 'Test Window' ;
   OPTIONS GetOptions ;
   FIT ;
   APPWINDOW oAppWindow ;
   EVAL {|o| oDialog := o}
;//   HANDLER TestHandler ;
;//   _MODAL nMode = 1

RETURN nil

* -------------

STATIC FUNCTION TestHandler( nEvent, mp1, mp2, oXbp, oDlg, GetList )

IF !nEvent == xbeM_Motion
//   WTF DC_AppEventDefine(nEvent)
ENDIF

RETURN DCGUI_NONE

*+
*+
*+    Function LB_VisualStyle(oXbp,lBrowse)
*+
*+
*+
FUNCTION LB_VisualStyle(oXbp,lBrowse)
  
  IF lBrowse = NIL
    lBrowse := .F.
  ENDIF
  
  IF version(3)>'331' .AND. version(3) < '341'
    oXbp:UseVisualStyle:=.F.
    IF lBrowse .AND. version(3) > '336'
      oXbp:HScrollObject:UseVisualStyle := .T.
      oXbp:VScrollObject:UseVisualStyle := .T. 
    ENDIF
  ENDIF
  IF version(3)>'341'
    IF lBrowse .AND. version(3) > '336'
      oXbp:HScrollObject:UseVisualStyle := .T.
      oXbp:VScrollObject:UseVisualStyle := .T. 
    ENDIF
  ENDIF
  RETURN NIL
  
*+<*>
*+
*+      STATIC Function S_ReOrder(IndexList1,IndexList2,IndexList3 aMainGetList)
*+
*+      Selects the current index order
*+
*+
*+
STATIC FUNCTION S_ReOrder(IndexList1,IndexList2,IndexList3, aMainGetList)
* Change the index for the active database
  LOCAL nindex := len(IndexList1), nTest := 0, i, GetList[0]
  LOCAL oRadioOrder[nIndex], GetOptions
  LOCAL cpOrder := SIMPLE->(OrdSetFocus())                                                //DM//
  
  @ .5,1 DCSAY ''
  
  nTest++
  I:=1
  @ I,1 DCRADIO nTest ;
    VALUE nTest ;
    OBJECT oRadioOrder[I] ;
    TABGROUP XBP_BEGIN_GROUP ;
    TABSTOP ;
    ACCELKEY ASC(alltrim(str(I,3))) ;
    PROMPT alltrim(str(I,3))+'. '+indexList2[I] ;
    ACTION {|| SIMPLE->(OrdSetFocus(IndexList1[nTest])), DC_GetRefresh(aMainGetList,,,,{"ORDNAME"}) } ;
    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND 
  
  FOR I := 2 TO  nIndex - 1
    nTest++
    @ I,1 DCRADIO nTest ;
      VALUE nTest ;
      OBJECT oRadioOrder[I] ;
      TABGROUP XBP_WITHIN_GROUP  ;
      ACCELKEY ASC(alltrim(str(I,3))) ;
      PROMPT alltrim(str(I,3))+'. '+indexList2[I] ;
      ACTION {|| SIMPLE->(OrdSetFocus(IndexList1[nTest])), DC_GetRefresh(aMainGetList,,,,{"ORDNAME"}) } ;
      COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND 
  NEXT I
  
  nTest++
  @ I,1 DCRADIO nTest ;
    VALUE nTest ;
    TABGROUP XBP_END_GROUP ;
    OBJECT oRadioOrder[I] ;   
    ACCELKEY ASC(alltrim(str(I,3))) ;
    PROMPT alltrim(str(I,3))+'. '+indexList2[I] ;
    ACTION {|| SIMPLE->(OrdSetFocus(IndexList1[nTest])), DC_GetRefresh(aMainGetList,,,,{"ORDNAME"}) } ;
    COLOR GRA_CLR_BLACK, GRA_CLR_BACKGROUND 
  
  nTest := MAX(1, ASCAN(IndexList1,SIMPLE->(OrdSetFocus())))
  
  DCGETOPTIONS  ICON DC_IconDefault() ;
    NOMINBUTTON ;
    NOMAXBUTTON ;
    BUTTONALIGN DCGUI_BUTTONALIGN_CENTER
  
  DCREAD GUI TITLE 'Select Order';
    BUTTONS DCGUI_BUTTON_OK ;
    OPTIONS GetOptions ;
    FIT;
    MODAL ;
    EVAL {|| SetAppFocus(oRadioOrder[nTest]) }
  
  RETURN NIL


*+
*+
*+      FUNCTION LB_PrintScreen(lPrintNow, lPostEsc, oDialog )
*+
*+
*+
FUNCTION LB_PrintScreen(lPrintNow,lPostEsc,oDialog )
  LOCAL oXbp, oBitMap                                                           // PC CAW 11-18-05 added oBitMap
  
  DEFAULT lPrintNow TO .F.
  DEFAULT lPostESC  TO .F.

//  m->G_oMsgBox:setcaption('Print Screen Selected')                              // PC CAW 11-08-05 added caption when deferred
//    
//  IF m->G_cDeferPScreen == 'P' .AND. !lPrintNow
//    RETURN NIL
//  ENDIF
//  
//  IF m->G_cDeferPScreen == "Y"
//    m->G_cDeferPScreen := 'P'
//    RETURN NIL
//  ENDIF
  
  oXbp := SetAppFocus()
  
  IF lPostEsc
    PostAppEvent(xbeP_Keyboard,xbeK_ESC,,oXbp)
    sleep(20)
  ENDIF
//dc_debugqout('scrn2clipboard')
//  DC_Scrn2ClipBoard(oDialog)
  oBitMap := LB_Scrn2ClipBoard(oDialog)                                         // PC CAW 11-18-05 added saving to bitmap
  sleep(50)

//  IF !m->G_lDisableF12                                                          // PC CAW 11-26-07 Added the ability to disable F12 key for Snagit Printing via PrintScreen Button

    LB_PrintClipBoard(.F.,oBitMap)                                              // PC CAW 11-18-05 added passing of bitmap

//  ELSE
//    LB_Warning({'That key is not currently available','Press PrintScreen Button!'})
////    keybd_event(VK_SNAPSHOT, 1, 0, 0)
////    keybd_event(VK_MENU, 0, 0, 0)
////    keybd_event(VK_SNAPSHOT, 0, 0, 0)
////    keybd_event(VK_SNAPSHOT, 0, KEYEVENTF_KEYUP, 0)
////    keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)
//  ENDIF

  sleep(50)
  SetAppFocus(oXbp)                                                             // .T. to preview

//  m->G_oMsgBox:setcaption('')                                                   // PC CAW 11-08-05 added caption when deferred
//  m->G_cDeferPScreen := 'N'
  RETURN NIL                      

*+          // PC CAW 12-30-05 modified to not do winapi printscreen if object passed
*+
*+      Function LB_Scrn2ClipBoard( oXbp )
*+
*+        Copies the specified object (oXbp) to clipboard or the application
*+        Application desktop if not specified
*+
*+
*+
FUNCTION LB_Scrn2ClipBoard( oXbp )

LOCAL oSourcePS, oBitmap, oClipBoard, aPos

  IF oXbp == NIL //.OR. .T.                                                      // PC CAW 12-15-05 changed to force old way always
                                                                                 // PC CAW 12-27-05 changed to modified new way
                                                                                 // PC CAW 11-26-07 added check for DisableF12 to avoid PrintScreen call twice
//    IF !m->G_lDisableF12                                                                                    
      keybd_event(VK_SNAPSHOT, 1, 0, 0)
      keybd_event(VK_MENU, 0, 0, 0)
      keybd_event(VK_SNAPSHOT, 0, 0, 0)
      keybd_event(VK_SNAPSHOT, 0, KEYEVENTF_KEYUP, 0)
      keybd_event(VK_MENU, 0, KEYEVENTF_KEYUP, 0)
//    ENDIF

  ELSE
    oSourcePS := oXbp:lockPS()
  
    IF oXbp:isDerivedFrom('XbpDialog')
      aPos := { -4, -4 }
    ELSE
      aPos := { 0, 0 }
    ENDIF

    oBitmap := GraSaveScreen( oSourcePS, aPos, oXbp:currentSize() )

//  oClipBoard := XbpClipboard():new():create()                         // PC CAW 12-28-05 commented out the save to clipboard
//  oClipBoard:open()
//  oClipBoard:setBuffer(oBitmap)
//  oClipBoard:close()
//  oClipBoard:destroy()
  
  ENDIF

  RETURN oBitmap

DLLFUNCTION keybd_event(mvkey, nscan, flags, xtra) USING STDCALL FROM USER32.DLL


*+
*+
*+      FUNCTION LB_PrintClipBoard( lPreview, oBitMap )
*+
*+
*+
FUNCTION LB_PrintClipBoard( lPreview, oBitMap )                                 // PC CAW 11-18-05 added oBitMap
  LOCAL aFormats, oClipBoard, oPrinter, oPrinter1, aPrinters, nPrinter          // PC CAW 11-18-05 deleted oBitMap 

  DEFAULT lPreview := .F.
                                                                                // PC CAW 11-18-05 if bitmap not passed, pull from clipboard

                                                                                // PC CAW 12-26-05 changed to process clipboard and also passed oBitMap
  IF oBitMap == NIL
    oClipboard := XbpClipboard():new():create()
    oClipBoard:open()
    aFormats := oClipBoard:queryFormats()
    IF AScan( aFormats, XBPCLPBRD_BITMAP ) > 0
      oBitmap := oClipBoard:getBuffer( XBPCLPBRD_BITMAP )
//      oClipboard:close()
//      oClipboard:clear()
      oClipboard:clear()                                                        // PC CAW 01-02-06 put clear before close
      oClipboard:close()
    ELSE
      oClipboard:close()                                                        // PC CAW 01-02-06 added close
      oClipboard:destroy()
      RETURN .F.
    ENDIF

    oClipboard:destroy()

  ENDIF
    
  oPrinter1 := XbpPrinter():new()
  aPrinters := oPrinter1:list()

  nPrinter := ascan(aPrinters,{|x| upper(x)=='SCREENPRINT'})

  IF lPreview
    DCPRINT ON PREVIEW TO oPrinter ZOOMFACTOR 2.5  ORIENTATION 2 
  ELSE
    IF nPrinter == 0
      DCPRINT ON TO oPrinter USEDEFAULT ORIENTATION 2             // COLORMODE XBPPRN_COLORMODE_OFF RESOLUTION XBPPRN_RESOLUTION_DRAFT     // PC CAW 05-24-04 added color mode/resolution
    ELSE
      DCPRINT ON TO oPrinter NAME aPrinters[nPrinter] ORIENTATION 2 RESOLUTION {300,300} // COLORMODE XBPPRN_COLORMODE_OFF RESOLUTION XBPPRN_RESOLUTION_DRAFT     // PC CAW 05-24-04 added color mode/resolution
    ENDIF
  ENDIF

  IF Valtype(oPrinter) # 'O' .OR. !oPrinter:lActive
    RETURN .F.
  ENDIF

  IF m->G_l1024
    @ 0, 1 DCPRINT BITMAP oBitMap PRINTER oPrinter SCALE 2.5           // 2

    @ 64,1 DCPRINT SAY 'Printed by ' + 'TEST' + '/' + 'CAW' + '-' + DtoC(Date()) + ' at ' + Time() ;
             PRINTER oPrinter

  ELSE
    @ 0,1 DCPRINT BITMAP oBitMap PRINTER oPrinter SCALE 2             // 1.6

    @ 64,1 DCPRINT SAY 'Printed by ' + 'TEST' + '/' + 'CAW' + '-' + DtoC(Date()) + ' at ' + Time() ;
             PRINTER oPrinter
  ENDIF
    
  DCPRINT OFF PRINTER oPrinter
  RETURN .T.
